//Map.java

import java.lang.*;
import java.io.*;
import java.awt.*;

class Map
{
	//system parameters
	int NetworkCount=2;	//number of networks
	Network MapNetworks[];	//networks list

	//constructor
	Map()
	{
		MapNetworks=new Network[NetworkCount];
		
		//set network IDs
		for(int t=0;t<NetworkCount;t++)
		{
			MapNetworks[t]=new Network();
			MapNetworks[t].setID(t);
		}
	
		//set networks screen pos
		MapNetworks[0].setXY(Globals.StartX,Globals.StartY);
		MapNetworks[1].setXY(Globals.StartX+Globals.NetworkWidth+20,Globals.StartY);
	}
	
	//get functions
	public Network[] getMapNetworks()
	{
		return(MapNetworks);
	}

	public int getNetworkCount()
	{
		return(NetworkCount);
	}
	
	//set functions
	public void setMapNetworks(Network[] tMapNetworks)
	{
		MapNetworks=tMapNetworks;
	}

	//methods
	//returns which network a node is present
	public int findNetworkNoOfNode(int tNodeIndex)
	{
		int tNetworkNo=-1;
		
		for(int t=0;t<NetworkCount;t++)
		{
			for(int j=0;j<MapNetworks[t].getNodeCount();j++)
			{
				if(MapNetworks[t].getNodeID(j)==tNodeIndex)
				{
					tNetworkNo=t;
				}
			}
		}
		
		return(tNetworkNo);
	}
	
	//returns index of a node inside a network
	public int findNodeIndexInNetwork(int tNodeIndex)
	{
		int tIndex=-1;
		
		for(int t=0;t<NetworkCount;t++)
		{
			for(int j=0;j<MapNetworks[t].getNodeCount();j++)
			{
				if(MapNetworks[t].getNodeID(j)==tNodeIndex)
				{
					tIndex=j;
				}
			}
		}
		
		return(tIndex);
	}
	
	public void draw(Graphics g)
	{
		try
		{
			for(int t=0;t<NetworkCount;t++)
			{
				MapNetworks[t].draw(g);
				Globals.wait(Globals.NetworkDrawDelay);
			}
		}
		catch(Exception e)
		{
			System.out.println("Error: "+e.getMessage());
		}
	}
	
	public void drawNodesLabel(Graphics g)
	{
		g.setFont(new Font("Verdana",Font.BOLD,13));
		g.setColor(Color.BLUE);
		for(int i=0;i<NetworkCount;i++)
		{
			g.drawString("network"+i,MapNetworks[i].getX()+55,MapNetworks[i].getY()+12);
		}
	}
}
