//Scheduling.java

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

public class Scheduling extends JFrame implements ActionListener,MouseMotionListener,MouseListener
{
	//mainform ui
	String strTitle="Bi-Directional Routing Abstraction";
	JFrame frmMain=new JFrame(strTitle);
	JLabel lblNodeCount=new JLabel("");
	JLabel lblXY=new JLabel("");
	JLabel lblCurrentNode=new JLabel("");
	JButton btAddNodes=new JButton("Add Nodes");
	JTextArea txtInput=new JTextArea("");
	JScrollPane spInput=new JScrollPane(txtInput);
	JButton btFCFS=new JButton("BRA");
	JButton btGA=new JButton("AODV");
	JTextArea txtStatus=new JTextArea("");
	JScrollPane spStatus=new JScrollPane(txtStatus);
	JTextArea txtResult=new JTextArea("");
	JScrollPane spResult=new JScrollPane(txtResult);
	
	//parameterform ui
	JFrame frmParameters=new JFrame("Parameters");
	JLabel lblSourceDataSize=new JLabel("Source DataSize:");
	JTextField txtSourceDataSize=new JTextField("2048");
	JLabel lblUnit1=new JLabel("KB");
	JLabel lblLinkSpeed=new JLabel("Link Speed:");
	JTextField txtLinkSpeed=new JTextField("128");
	JLabel lblUnit2=new JLabel("KB/s");
	
	//ui parameters
	Graphics g;
	int frmLeft=20,frmTop=60;
	int frmWidth=680,frmHeight=450;
	int mapStartX=30,mapStartY=60;
	int mapWidth=440,mapHeight=350;
	int nodeWidth=31,nodeHeight=28;
	
	//graph ui
	JFrame frmGraph=new JFrame("Comparison");
	Graphics g1;
	Graphics2D g2d1;
	
	//graph ui parameters
	int formtitleheight=30;
	int xaxisTextHeight=30;
	int graphleft=20;
	int graphtop=15;
	int graphwidth;
	int graphheight;
	
	//system parameters
	int CurrentNode=-1;
	int nNodes=0;
	int TransmissionRange=90;
	long tseconds=0;
	int Switch=-1;
	int xmaxmain=0;
	
	//data transfer declarations
	ArrayList SrcNodes=new ArrayList();
	ArrayList DestNodes=new ArrayList();
	
	Map map=new Map();
	Network[] MapNetworks=map.getMapNetworks();
	
	//constructor
	Scheduling()
	{
		//mainform ui
		frmMain.setResizable(false);
		frmMain.setBounds(frmLeft,frmTop,frmWidth,frmHeight);
		frmMain.getContentPane().setLayout(null);
		frmMain.setDefaultCloseOperation(EXIT_ON_CLOSE);
		frmMain.addMouseMotionListener(this);
		frmMain.addMouseListener(this);
		
		lblXY.setBounds(30,10,100,20);
		frmMain.getContentPane().add(lblXY);

		lblNodeCount.setBounds(mapStartX+2,frmHeight-65,150,20);
		frmMain.getContentPane().add(lblNodeCount);

		lblCurrentNode.setBounds(mapStartX+mapWidth-105,frmHeight-65,150,20);
		frmMain.getContentPane().add(lblCurrentNode);

		btAddNodes.setBounds(frmWidth-160-30,30,160,22);
		btAddNodes.addActionListener(this);
		frmMain.getContentPane().add(btAddNodes);
		
		txtInput.setEditable(false);
		spInput.setBounds(frmWidth-160-30,60,160,60);
		spInput.setColumnHeaderView(new JLabel("Input:"));
		frmMain.getContentPane().add(spInput);
		
		btFCFS.setBounds(frmWidth-160-30,125,160,22);
		btFCFS.addActionListener(this);
		frmMain.getContentPane().add(btFCFS);
		
		btGA.setBounds(frmWidth-160-30,155,160,22);
		btGA.addActionListener(this);
		frmMain.getContentPane().add(btGA);
		
		txtStatus.setEditable(false);
		spStatus.setBounds(frmWidth-160-30,185,160,90);
		spStatus.setColumnHeaderView(new JLabel("Status:"));
		frmMain.getContentPane().add(spStatus);
		
		txtResult.setEditable(false);
		spResult.setBounds(frmWidth-160-30,285,160,100);
		spResult.setColumnHeaderView(new JLabel("Result:"));
		frmMain.getContentPane().add(spResult);
		
		//parameterform ui
		frmParameters.setResizable(false);
		frmParameters.setBounds(frmLeft+frmWidth,frmTop,300,210);
		frmParameters.getContentPane().setLayout(null);
		
		lblSourceDataSize.setBounds(10,10,120,20);
		lblSourceDataSize.setHorizontalAlignment(SwingConstants.RIGHT);
		frmParameters.getContentPane().add(lblSourceDataSize);
		txtSourceDataSize.setBounds(140,10,70,20);
		frmParameters.getContentPane().add(txtSourceDataSize);
		lblUnit1.setBounds(215,9,40,20);
		frmParameters.getContentPane().add(lblUnit1);
		
		lblLinkSpeed.setBounds(10,35,120,20);
		lblLinkSpeed.setHorizontalAlignment(SwingConstants.RIGHT);
		frmParameters.getContentPane().add(lblLinkSpeed);
		txtLinkSpeed.setBounds(140,35,70,20);
		frmParameters.getContentPane().add(txtLinkSpeed);
		lblUnit2.setBounds(215,34,40,20);
		frmParameters.getContentPane().add(lblUnit2);
		
		//graph ui
		frmGraph.setResizable(false);
		frmGraph.setBounds(frmLeft+frmWidth,frmTop+frmHeight/2,300,210);
		frmGraph.getContentPane().setLayout(null);
		
		frmParameters.setVisible(true);
		frmGraph.setVisible(true);
		frmMain.setVisible(true);
		Globals.wait(1000);
		
		g=frmMain.getGraphics();
		Graphics2D g2d=(Graphics2D)g;
		g2d.setStroke(new BasicStroke(2.0f));
		g2d.drawRect(mapStartX,mapStartY,mapWidth,mapHeight);
		
		//draw background
		Image timg=new ImageIcon("data\\background.gif").getImage();
		g.drawImage(timg,mapStartX,mapStartY,mapWidth,mapHeight,this);
		
		//draw map
		map.draw(g);
		map.drawNodesLabel(g);
	}

	//events
	public void actionPerformed(ActionEvent evt)
	{
		if(evt.getSource()==btAddNodes)
		{
			addNodes();
			displayStatus();
		}
		else if(evt.getSource()==btFCFS)
		{
			if(DestNodes.size()>0)
			{
				long tstart=System.currentTimeMillis();
				
				PathCollection paths=new PathCollection();
				for(int k=0;k<DestNodes.size();k++)
				{
					int tsource=((Integer)SrcNodes.get(k)).intValue();
					int tdest=((Integer)DestNodes.get(k)).intValue();
					
					Path tpath=findPath(tsource,tdest);
					paths.addPath(tpath);
				}
				showPaths(paths);
				fcfs(paths);
				
				long tend=System.currentTimeMillis();
				double tseconds=((double)(tend-tstart))/(double)1000;
				txtResult.setText("Time: "+tseconds+" seconds");
			}
		}
		else if(evt.getSource()==btGA)
		{
			if(DestNodes.size()>0)
			{
				long tstart=System.currentTimeMillis();
				
				PathCollection paths=new PathCollection();
				for(int k=0;k<DestNodes.size();k++)
				{
					int tsource=((Integer)SrcNodes.get(k)).intValue();
					int tdest=((Integer)DestNodes.get(k)).intValue();
					
					Path tpath=findPath(tsource,tdest);
					paths.addPath(tpath);
				}
				showPaths(paths);
				ga(paths);
				
				long tend=System.currentTimeMillis();
				double tseconds=((double)(tend-tstart))/(double)1000;
				txtResult.setText("Time: "+tseconds+" seconds");
			}
		}
	}
	
	//mouse motion listener events
	public void mouseDragged(MouseEvent me)
	{
		//
	}
	
	public void mouseMoved(MouseEvent me)
	{
		int xposition=me.getX();
		int yposition=me.getY();
		
		if(between(xposition,yposition,mapStartX,mapStartY,mapStartX+mapWidth,mapStartY+mapHeight)==true)
		{
			lblXY.setText("("+(xposition-mapStartX)+","+(yposition-mapStartY)+")");
		}
		
		//display currentnode
		boolean flag=false;
		for(int i=0;i<map.getNetworkCount();i++)
		{
			for(int j=0;j<MapNetworks[i].getNodeCount();j++)
			{
				int x1=MapNetworks[i].getNodeX(j);
				int y1=MapNetworks[i].getNodeY(j);
				int x2=MapNetworks[i].getNodeX(j)+nodeWidth;
				int y2=MapNetworks[i].getNodeY(j)+nodeHeight;

				if(between(xposition,yposition,x1,y1,x2,y2)==true)
				{
					flag=true;
					CurrentNode=MapNetworks[i].getNodeID(j);
				}
			}
		}

		//make sure nodeid is displayed only when mouse is over it
		if(flag==false) CurrentNode=-1;
		displayStatus();
	}
	
	//mouselistener methods
	public void mouseClicked(MouseEvent me)
	{
		if(CurrentNode!=-1)
		{
			if(me.getButton()==MouseEvent.BUTTON1)
			{
				boolean found=false;
				for(int t=0;t<SrcNodes.size();t++)
				{
					int tsource=((Integer)SrcNodes.get(t)).intValue();
					if(tsource==CurrentNode)
					{
						found=true;
						break;
					}
				}
				if(found==false) SrcNodes.add(new Integer(CurrentNode));
			}
			else if(me.getButton()==MouseEvent.BUTTON3)
			{
				boolean found=false;
				for(int t=0;t<DestNodes.size();t++)
				{
					int tdest=((Integer)DestNodes.get(t)).intValue();
					if(tdest==CurrentNode)
					{
						found=true;
						break;
					}
				}
				if(found==false) DestNodes.add(new Integer(CurrentNode));
			}
			
			displayStatus();
		}
	}
	
	public void mouseEntered(MouseEvent me)
	{
		//
	}
	
	public void mouseExited(MouseEvent me)
	{
		//
	}
	
	public void mousePressed(MouseEvent me)
	{
		//
	}
	
	public void mouseReleased(MouseEvent me)
	{
		//
	}
	
	//internal methods
	private void displayStatus()
	{
		lblNodeCount.setText("NodeCount: "+(nNodes-1));
		lblCurrentNode.setText("Current Node: "+CurrentNode);
		String tstr="Source Nodes ["+SrcNodes.size()+"]: ";
		for(int t=0;t<SrcNodes.size();t++)
		{
			int tsource=((Integer)SrcNodes.get(t)).intValue();
			tstr+=tsource+",";
		}
		tstr=tstr.substring(0,tstr.length()-1)+"\n";
		tstr+="Dest Nodes ["+DestNodes.size()+"]: ";
		for(int t=0;t<DestNodes.size();t++)
		{
			int tdest=((Integer)DestNodes.get(t)).intValue();
			tstr+=tdest+",";
		}
		tstr=tstr.substring(0,tstr.length()-1);
		txtInput.setText(tstr);
	}
	
	private boolean between(int x,int y,int x1,int y1,int x2,int y2)
	{
		boolean flag=false;
		
		if(x>=x1 && x<=x2)
		{
			if(y>=y1 && y<=y2)
			{
				flag=true;
			}
		}
		
		return(flag);
	}
	
	//methods
	void addNodes()
	{
		try
		{
			int twidth=Globals.NetworkWidth/3;
			int theight=Globals.NetworkHeight/5;
			for(int nid=0;nid<=1;nid++)
			{
				for(int tx=0;tx<3;tx++)
				{
					for(int ty=0;ty<5;ty++)
					{
						//select random x
						double random1=java.lang.Math.random();
						int nodex=(int)((double)(twidth-nodeWidth)*random1);
						int xposition=MapNetworks[nid].getX()+nodex+(twidth*tx);
						
						//select random y
						double random2=java.lang.Math.random();
						int nodey=(int)((double)(theight-nodeHeight)*random2);
						int yposition=MapNetworks[nid].getY()+nodey+(theight*ty);
						
						//set node color
						Graphics2D g2d=(Graphics2D)g;
						g2d.setStroke(new BasicStroke(2.0f));
						g.setColor(new Color(255,0,0));
						
						//draw node
						Image timg=new ImageIcon("data\\node.gif").getImage();
						g.drawImage(timg,xposition,yposition,nodeWidth,nodeHeight,this);
						MapNetworks[nid].addNode(xposition,yposition);
						nNodes+=1;
						Globals.wait(Globals.NodesAddDelay);
					}
				}
			}
			
			//add switch
			int tx=MapNetworks[0].getX()+Globals.NetworkWidth-7;
			int ty=MapNetworks[0].getY()+Globals.NetworkHeight/2-7;
			Image timg=new ImageIcon("data\\switch.gif").getImage();
			g.drawImage(timg,tx,ty,34,28,this);
			MapNetworks[0].addNode(tx,ty);
			nNodes+=1;
			Switch=nNodes-1;
			
		}
		catch(Exception err)
		{
			System.out.println("Error: "+err);
			System.exit(-1);
		}
	}
	
	//data transfer methods
	private int findNodeX(int tNodeID)
	{
		int tX=MapNetworks[map.findNetworkNoOfNode(tNodeID)].getNodeX(map.findNodeIndexInNetwork(tNodeID));
		return(tX);
	}
	
	private int findNodeY(int tNodeID)
	{
		int tY=MapNetworks[map.findNetworkNoOfNode(tNodeID)].getNodeY(map.findNodeIndexInNetwork(tNodeID));
		return(tY);
	}
	
	private int findDistance(int x1,int y1,int x2,int y2)
	{
		double d=Math.sqrt(Math.pow((double)(x2-x1),2.0)+Math.pow((double)(y2-y1),2.0));
		return((int)d);
	}
	
	private int findNodeDistance(int tNodeID1,int tNodeID2)
	{
		int x1=findNodeX(tNodeID1);
		int y1=findNodeY(tNodeID1);
		int x2=findNodeX(tNodeID2);
		int y2=findNodeY(tNodeID2);
		double tdistance=findDistance(x1,y1,x2,y2);
		return((int)tdistance);
	}
	
	private Path findPathTemp(int tsourcenode,int tdestnode)
	{
		Path tpath=new Path();
		if(tsourcenode==tdestnode) return(tpath);
		
		int x[],y[],distances[][];
		int n=nNodes;
		x=new int[n];
		y=new int[n];
		distances=new int[n][n];
		int x1,x2,y1,y2;

		for(int i=0;i<n;i++)
		{
			x[i]=findNodeX(i);
			y[i]=findNodeY(i);
		}
		
		//find euclidean distance between each node and every other node (routing table)
		for(int i=0;i<n;i++)
		{
			for(int j=0;j<n;j++)
			{
				x1=x[i]; x2=x[j];
				y1=y[i]; y2=y[j];
				
				distances[i][j]=findDistance(x1,y1,x2,y2);
			}
		}
		
		int tsource=tsourcenode;
		int tdestination=tdestnode;
		int neighbors[]=new int[n];
		int neighborCount=0;
		tpath.addNode(tsource); //add sourcenode to path
		
		boolean destReached=false;
		while(destReached==false)
		{
			//find neighbor nodes that are within the transmission range
			neighborCount=0;
			for(int i=0;i<n;i++)
			{
				if(distances[tsource][i]<=TransmissionRange)
				{
					if(i!=tsource) //to ensure source itself is not taken as a neighbor
					{
						//find if this neighbor is already in path
						boolean found=false;
						for(int k=0;k<tpath.size();k++)
						{
							if(tpath.getNode(k)==i)
							{
								found=true;
								break;
							}
						}
						
						if(found==false)
						{
							neighbors[neighborCount]=i;
							neighborCount++;
						}
					}
				}
			}

			if(neighborCount>0)
			{
				//check if DestinationNode reached
				for(int i=0;i<neighborCount;i++)
				{
					if(neighbors[i]==tdestnode)
					{
						tpath.addNode(tdestnode);
						destReached=true;
						break;
					}
				}
				if(destReached==true)
				{
					break;
				}
				
				//find the next-node as neighbor-node with shortest distance to the target node
				int nextNode=-1;
				int tnext=0,tdist,shortestDist=0;
				for(int i=0;i<neighborCount;i++)
				{
					int tnode=neighbors[i];
					x1=x[tnode]; x2=x[tdestnode];
					y1=y[tnode]; y2=y[tdestnode];
					tdist=findDistance(x1,y1,x2,y2);
					
					if(i==0)
					{
						shortestDist=tdist;
						tnext=tnode;
					}
					else if(shortestDist>tdist)
					{
						shortestDist=tdist;
						tnext=tnode;
					}
				}
				nextNode=tnext;
				
				tpath.addNode(nextNode);
				tsource=nextNode;
			}
			else
			{
				//if no neighbor found inside the transmission range
				break;
			}
		}
		
		//find path distance
		double tdistance=0.0;
		for(int t=0;t<tpath.size();t++)
		{
			if(t>0)
			{
				int node1=tpath.getNode(t-1);
				int node2=tpath.getNode(t);
				tdistance+=findNodeDistance(node1,node2);
			}
		}
		tpath.setDistance(tdistance);
		
		return(tpath);
	}
	
	private Path findPath(int tsource,int tdest)
	{
		Path path1=findPathTemp(tsource,Switch);
		Path path2=findPathTemp(Switch,tdest);
		path1.appendPath(path2);
		return(path1);
	}
	
	private void drawPath(int tindex1,int tindex2)
	{
		int x=findNodeX(tindex1)+nodeWidth/2;
		int y=findNodeY(tindex1)+nodeHeight/2;
		int x1=findNodeX(tindex2)+nodeWidth/2;
		int y1=findNodeY(tindex2)+nodeHeight/2;
		Graphics2D g2d=(Graphics2D)g;
		g2d.setStroke(new BasicStroke(3.0f));
		g2d.drawLine(x,y,x1,y1);
	}
	
	private void fcfs(PathCollection tpaths)
	{
		int totalsize=Integer.parseInt(txtSourceDataSize.getText())*1024;
		int speed=Integer.parseInt(txtLinkSpeed.getText())*1024;
		int qlength=600; //cells (packets)
		int packetlength=32; //one packet=32 bytes
		int unitsize=packetlength*qlength,tbandwidth=0; //determine data transfer speed
		unitsize=(int)((double)speed*(1.0-(double)0.7));
		
		long tstart=System.currentTimeMillis();
		initializeGraph();
		xmaxmain=(int)((double)totalsize/(double)unitsize);
		for(int i=0,tindex=0;i<tpaths.size();i++)
		{
			Path tpath=tpaths.getPath(i);
			
			int delivered=0;
			while(delivered<totalsize)
			{
				for(int t=0;t<tpath.size();t++)
				{
					if(t>0)
					{
						int node1=tpath.getNode(t-1);
						int node2=tpath.getNode(t);
						g.setColor(new Color(255,0,0));
						drawPath(node1,node2);
						delivered+=unitsize;
						if(delivered>=totalsize) break;
						
						long tend=System.currentTimeMillis();
						double tseconds=((double)(tend-tstart))/(double)1000;
						double trate=((double)delivered/(double)tseconds);
						tbandwidth=(int)(trate/1024.0);
						showDelivered(delivered,tbandwidth);
						drawGraph(tindex,tbandwidth,0);
						tindex+=1;
					}
					Globals.wait(Globals.DataTransferDelay);
				}
				showPaths(tpaths);
			}
			delivered=totalsize;
			showDelivered(delivered,tbandwidth);
		}
		frmMain.setTitle(strTitle);
		
		displayStatus();
	}
	
	private void ga(PathCollection tpaths)
	{
		int totalsize=Integer.parseInt(txtSourceDataSize.getText())*1024;
		int speed=Integer.parseInt(txtLinkSpeed.getText())*1024;
		int qlength=400; //cells (packets)
		int packetlength=32; //one packet=32 bytes
		int unitsize=packetlength*qlength,tbandwidth=0; //determine data transfer speed
		unitsize=(int)((double)speed*(1.0-(double)0.85));
		
		long tstart=System.currentTimeMillis();
		initializeGraph();
		xmaxmain=(int)((double)totalsize/(double)unitsize);
		for(int i=0,tindex=0;i<tpaths.size();i++)
		{
			Path tpath=tpaths.getPath(i);
			
			int delivered=0;
			while(delivered<totalsize)
			{
				for(int t=0;t<tpath.size();t++)
				{
					if(t>0)
					{
						int node1=tpath.getNode(t-1);
						int node2=tpath.getNode(t);
						g.setColor(new Color(255,0,0));
						drawPath(node1,node2);
						delivered+=unitsize;
						if(delivered>=totalsize) break;
						
						long tend=System.currentTimeMillis();
						double tseconds=((double)(tend-tstart))/(double)1000;
						double trate=((double)delivered/(double)tseconds);
						tbandwidth=(int)(trate/1024.0);
						showDelivered(delivered,tbandwidth);
						drawGraph(tindex,tbandwidth,1);
						tindex+=1;
					}
					Globals.wait(Globals.DataTransferDelay);
				}
				showPaths(tpaths);
			}
			delivered=totalsize;
			showDelivered(delivered,tbandwidth);
		}
		frmMain.setTitle(strTitle);
		
		displayStatus();
	}
	
	private void showDelivered(int tdelivered,int tbandwidth)
	{
		String tstr="delivered: "+tdelivered+" bytes, bandwidth@router: "+tbandwidth+" kbps";
		System.out.print(tstr+"           \r");
		frmMain.setTitle(tstr);
		
		txtStatus.setText("delivered: "+tdelivered+" bytes\r\nbandwidth@router: "+tbandwidth+" kbps");
		txtStatus.revalidate();
	}
	
	private void showPaths(PathCollection tpaths)
	{
		if(tpaths.size()>0)
		{
			for(int i=0;i<tpaths.size();i++)
			{
				Path tpath=tpaths.getPath(i);
				for(int t=0;t<tpath.size();t++)
				{
					if(t>0)
					{
						int node1=tpath.getNode(t-1);
						int node2=tpath.getNode(t);
						g.setColor(new Color(0,128,0));
						drawPath(node1,node2);
					}
				}
			}
		}
	}
	
	//graph functions
	private void initializeGraph()
	{
		//initialize graph
		g1=frmGraph.getGraphics();
		g2d1=(Graphics2D)g1;
		g2d1.setStroke(new BasicStroke(2.0f));
		graphwidth=frmGraph.getWidth()-graphleft-20;
		graphheight=frmGraph.getHeight()-formtitleheight-xaxisTextHeight-30;
		
		//draw graph border
		g2d1.setColor(new Color(0,0,0));
		g2d1.drawRect(graphleft,formtitleheight+graphtop,graphwidth,graphheight);
		
		//draw legends
		int ty=frmGraph.getHeight()-32;
		g2d1.setColor(new Color(128,0,0));
		g2d1.drawLine(30,ty,50,ty);
		g2d1.drawString("AODV",60,ty+3);
		
		g2d1.setColor(new Color(0,0,128));
		g2d1.drawLine(94,ty,114,ty);
		g2d1.drawString("BRA",124,ty+3);
		
		//draw axes
		g2d1.setColor(new Color(0,0,0));
		g2d1.drawString("x-axis: time; y-axis: bandwidth@router",30,frmGraph.getHeight()-12);
	}
	
	private ArrayList tlist_fcfs=new ArrayList();
	private ArrayList tlist_ga=new ArrayList();
	private void drawGraph(int tindex,int tbandwidth,int tid)
	{
		if(tid==0)
		{
			tlist_fcfs.add(new Point(tlist_fcfs.size()+1,tbandwidth));
			drawStatistics(tlist_fcfs,new Color(128,0,0));
		}
		else if(tid==1)
		{
			tlist_ga.add(new Point(tlist_ga.size()+1,tbandwidth));
			drawStatistics(tlist_ga,new Color(0,0,128));
		}
	}
	
	private void drawStatistics(ArrayList tlist,Color lineColor)
	{
		g2d1.setColor(lineColor);
		int xmax=xmaxmain*2;
		double xinc=(double)graphwidth/(double)xmax;
		int ymax=256;
		double yinc=(double)(graphheight-graphtop)/(double)ymax;
		
		//generate graph points
		int xpoints[]=new int[tlist.size()];
		int ypoints[]=new int[tlist.size()];
		for(int t=0;t<tlist.size();t++)
		{
			Point tpoint=(Point)tlist.get(t);
			double xval=(double)tpoint.x;
			double yval=(double)tpoint.y;
			xval*=1.9;
			int graphx=(int)((double)graphleft+(xval*xinc));
			int graphy=(int)((double)(graphtop+formtitleheight+graphheight-6)-(yval*yinc));
			xpoints[t]=graphx;
			ypoints[t]=graphy;
		}
		
		//draw graph
		for(int t=0;t<tlist.size()-1;t++)
		{
			g2d1.drawLine(xpoints[t],ypoints[t],xpoints[t+1],ypoints[t+1]);
		}
	}
	
	//main
	public static void main(String args[])
	{
		new Scheduling();
	}
}
